LeetCode #213 - House Robber II

题目描述:

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.

Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

和House Robber类似,只是这道题中房子是围成一圈的,所以选了数组第一个元素之后就不能选最后一个元素了。其实要解决这个问题也不难,可以分别考虑①不包含第一个元素的数组②不包含最后一个元素的数组,然后求出最大值即可。

class Solution {
public:
    int rob(vector<int>& nums) {
        int n=nums.size();
        if(n==0) return 0;
        else if(n==1) return nums[0];
        else if(n==2) return max(nums[0],nums[1]);
        vector<int> n1(nums.begin(),nums.end()-1);
        vector<int> n2(nums.begin()+1,nums.end());
        return max(rob_without_circle(n1),rob_without_circle(n2));
    }
    
    int rob_without_circle(vector<int> nums)
    {
        int n=nums.size();
        if(n==0) return 0;
        else if(n==1) return nums[0];
        else if(n==2) return max(nums[0],nums[1]);
        vector<int> dp(n,0);
        dp[0]=nums[0];
        dp[1]=max(nums[0],nums[1]);
        for(int i=2;i<n;i++) dp[i]=max(dp[i-1],dp[i-2]+nums[i]);
        return dp[n-1];
    }
};

猜你喜欢

转载自blog.csdn.net/lawfile/article/details/81175523
今日推荐